org.wildfly.swarm.spi.api

## Class Module

- java.lang.Object
- - org.wildfly.swarm.spi.api.Module

-     public class Module
      extends Object

  JBoss Modules module descriptor.

  If a module is added to an archive, this descriptor is returned in order to allow specific customization regarding exports, services, etc.

  Author:
    Ken Finnigan
  See Also:
    `JBossDeploymentStructureContainer.addModule(String)`, `JBossDeploymentStructureContainer.addModule(String, String)`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Module.ServiceHandling`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Boolean` | `export()` Determine if this module should be exported.
    `List<String>` | `exportExcludePaths()` Retrieve the list of paths excluded from exportation from this module.
    `List<String>` | `exportIncludePaths()` Retrieve this list of paths exported from this module.
    `List<String>` | `importExcludePaths()` Retreive the list of paths excluded from importation from this module.
    `List<String>` | `importIncludePaths()` Retrieve the list of paths imported from this module.
    `String` | `metaInf()` Retrieve the meta-inf disposition.
    `String` | `name()` The name of the module.
    `Boolean` | `optional()` Determine if this module is considered optional.
    `Module.ServiceHandling` | `services()` Retrieve the services flag.
    `String` | `slot()` The slot of the module.
    `Module` | `withExport(Boolean export)` Set the flag to determine if this module should be exported.
    `Module` | `withExportExcludePath(String path)` Add a path to exclude from exporting from this module.
    `Module` | `withExportIncludePath(String path)` Add a path to export from this module.
    `Module` | `withImportExcludePath(String path)` Add a path to exclude from importing from this module.
    `Module` | `withImportIncludePath(String path)` Add a path to import from this module.
    `Module` | `withMetaInf(String metaInf)` Set the meta-inf disposition.
    `Module` | `withOptional(Boolean optional)` Set the optional flag.
    `Module` | `withServices(Module.ServiceHandling services)` Set the services flag.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### name

          public String name()

      The name of the module.
      Returns:
        The name of the module.

    - #### slot

          public String slot()

      The slot of the module.
      Returns:
        The slot of the module.

    - #### export

          public Boolean export()

      Determine if this module should be exported.
      Returns:
        `null` if undefined, otherwise `true` if the module is to be exported, otherwise `false`.

    - #### withExport

          public Module withExport(Boolean export)

      Set the flag to determine if this module should be exported.
      Parameters:
        `export` - The flag.
      Returns:
        this module descriptor.

    - #### services

          public Module.ServiceHandling services()

      Retrieve the services flag.
      Returns:
        The services flag.

    - #### withServices

          public Module withServices(Module.ServiceHandling services)

      Set the services flag.
      Parameters:
        `services` - The services flag.
      Returns:
        this module descriptor.

    - #### optional

          public Boolean optional()

      Determine if this module is considered optional.
      Returns:
        `null` if undefined, otherwise `true` if the module is optional, otherwise `false`.

    - #### withOptional

          public Module withOptional(Boolean optional)

      Set the optional flag.
      Parameters:
        `optional` - The optional flag.
      Returns:
        this module.

    - #### metaInf

          public String metaInf()

      Retrieve the meta-inf disposition.
      Returns:
        The meta-inf disposition.

    - #### withMetaInf

          public Module withMetaInf(String metaInf)

      Set the meta-inf disposition.
      Parameters:
        `metaInf` - The meta-inf disposition.
      Returns:
        this module.

    - #### importIncludePaths

          public List<String> importIncludePaths()

      Retrieve the list of paths imported from this module.
      Returns:
        The list of paths imported from this module.

    - #### importExcludePaths

          public List<String> importExcludePaths()

      Retreive the list of paths excluded from importation from this module.
      Returns:
        The list of paths excluded from importation from this module.

    - #### withImportIncludePath

          public Module withImportIncludePath(String path)

      Add a path to import from this module.
      Parameters:
        `path` - The path to add.
      Returns:
        this module descriptor.

    - #### withImportExcludePath

          public Module withImportExcludePath(String path)

      Add a path to exclude from importing from this module.
      Parameters:
        `path` - The excluded path to add.
      Returns:
        this module descriptor.

    - #### exportIncludePaths

          public List<String> exportIncludePaths()

      Retrieve this list of paths exported from this module.
      Returns:
        The list of paths exported from this module.

    - #### exportExcludePaths

          public List<String> exportExcludePaths()

      Retrieve the list of paths excluded from exportation from this module.
      Returns:
        The list of paths excluded from exportation from this module.

    - #### withExportIncludePath

          public Module withExportIncludePath(String path)

      Add a path to export from this module.
      Parameters:
        `path` - The path to add.
      Returns:
        this module descriptor.

    - #### withExportExcludePath

          public Module withExportExcludePath(String path)

      Add a path to exclude from exporting from this module.
      Parameters:
        `path` - The excluded path to add.
      Returns:
        this module descriptor.

Copyright © 2017 JBoss by Red Hat. All rights reserved.